// GB_SOUND.H

#include <e32base.h>

#if !defined(_GBSOUND_)

#define _GBSOUND_


class MAudioBase
	{
public:
	virtual TInt Connect(TInt aVersion) = 0;
	virtual void Close() = 0;
	virtual TBool SoundLoaded(TInt aId) = 0;
	virtual void LoadSoundL(TInt aId, TInt aFrequency, const TDesC8& aData) = 0;
	virtual void PlaySound(TInt aId, TInt aVolume) = 0;
	virtual void UnloadSound(TInt aId) = 0;
	virtual void UnloadAll() = 0;
	virtual void SetMaxMemory(TInt aMem) = 0;
	virtual void StopSound(TInt aId) = 0;
	virtual TInt LoadAudioPlayer(const TDesC& aName) = 0;
	virtual void CloseAudioPlayer() = 0;
	virtual TInt Command(TInt aOpcode, TInt aArgument) = 0;
	virtual TInt Message(TInt aOpcode, const TDesC& aArgument) = 0;
	virtual TInt Message(TInt aOpcode, const TDesC8& aArgument) = 0;
	virtual TInt Query(TInt aOpcode, TDes* aReturnValue) = 0;
	virtual TInt Query(TInt aOpcode, TDes8* aReturnValue) = 0;
	virtual void Play() = 0;
	virtual void Stop() = 0;
	virtual void Register(const TDesC8& aRegistration);
	};


class CGBSound : public CBase
	{
public:
	CGBSound();
	~CGBSound();
	void ConstructL();
	TBool IsSoundOn();
	void SetSoundOn(TBool aTrue);
	TBool SubmitAudio(char* aPtr, TInt aLen);
private:
	void GetAudioL();
	void StartAudio();
	void CloseAudio();
private:
	RLibrary iAudioLib;
	MAudioBase* iAudio;
	TBool iSoundOn;
	TBool iConnected;
	TBool iSoundHasTerminated;
	};


#endif
